<?php

namespace Factory;

use \Teknisa\Model\Teknisa\Entities;

class Soliserv {


    public function saveOrcasolicita(Entities\Orcasolicita $entity = null, Entities\Soliserv $soliserv,$budgetItemId)
    {
        if (!$entity) {
            $entity = new Entities\Orcasolicita();
            $entity->setCditorcaprod($budgetItemId);
        }
        $entity->setCdfilial($soliserv->getCdfilial());
        $entity->setNrorg($soliserv->getNrorg());
        $entity->setNrsoliserv($soliserv->getNrsoliserv());
        return $entity;
    }

    public function createParcsoliserv( Entities\Soliserv $soliserv,$numPlot,$value)
    {

        $entity = new Entities\Parcsoliserv();
        $entity->setCdfilial($soliserv->getCdfilial());
        $entity->setNrorg($soliserv->getNrorg());
        $entity->setNrsoliserv($soliserv->getNrsoliserv());
        $entity->setNrparcsoli($numPlot);
        $entity->setVrparcsoli($value);
        return $entity;
    }

    public function updateParcsoliserv( Entities\Parcsoliserv $entity,$numPlot,$value)
    {
        $entity->setNrparcsoli($numPlot);
        $entity->setVrparcsoli($value);
        return $entity;
    }

    public function setOrcasolicitaEstimatValues(Entities\Orcasolicita $entity)
    {
        $entity->setQtitorcsocal($entity->getQtitorcsolic());
        $entity->setVrorcsolical($entity->getVrorcadosoli());

        return $entity;
    }

    public function createSolicitacao($cdfilial, $cdrelverorig, $cdpatrelorig, $nrpriosoli, $dsrefesoli, $cdassunto, $cdoperador,
                                      $cdprodcomp, $cdprodgrup, $cdverproorig, $cdcliente, $cdfasetram, $idstatussoli, $idsolience,
                                      $idsoliorca, $nrlicencauso, $idresdispver, $cdopersoli, $cdoperresp, $idsolilida, $dtabersoli) {
        $entity = new Entities\Soliserv();
        $entity->setCdfilial($cdfilial);
        $entity->setCdrelverorig($cdrelverorig);
        $entity->setCdpatrelorig($cdpatrelorig);
        $entity->setnrpriosoli($nrpriosoli);
        $entity->setDsrefesoli($dsrefesoli);
        $entity->setCdassunto($cdassunto);
        $entity->setCdoperador($cdoperador);
        $entity->setCdprodcomp($cdprodcomp);
        $entity->setCdprodgrup($cdprodgrup);
        $entity->setCdverproorig($cdverproorig);
        $entity->setCdcliente($cdcliente);
        $entity->setCdfasetram($cdfasetram);
        $entity->setIdstatussoli($idstatussoli);
        $entity->setIdsolience($idsolience);
        $entity->setIdsoliorca($idsoliorca);
        $entity->setNrlicencauso($nrlicencauso);
        $entity->setIdresdispver($idresdispver);
        $entity->setIdsolilida($idsolilida);
        $entity->setCdopersoli($cdopersoli);
        $entity->setCdoperresp($cdoperresp);
        $entity->setDtabersoli($dtabersoli);
        return $entity;
    }

    public function insertDescsoli($connection, $nrsoliserv, $descsoli, $cdfilial)
    {
        $insert = <<<SQL
            INSERT INTO DESCSOLI
                (CDFILIAL,
                NRSOLISERV,
                DSSOLISERV)
            VALUES (
                :CDFILIAL,
                :NRSOLISERV,
                RAWTOHEX(:DSSOLISERV))
SQL;

        $params = array(
            "CDFILIAL"   => $cdfilial,
            "DSSOLISERV" => $descsoli,
            "NRSOLISERV" => $nrsoliserv,
        );
        $connection->executeQuery($insert, $params);
    }

    public function createDescplativ($cdfilial, $nrtarefa, $nrplativtare)
    {

        $entity = new Entities\Descplativ();
        $entity->setCdfilial($cdfilial);
        $entity->setNrtarefa($nrtarefa);
        $entity->setNrplativtare($nrplativtare);
        return $entity;
    }
    
    public function updateDescplativ(Entities\Descplativ $entity, $cdfilial, $nrtarefa, $nrplativtare)
    {
        $entity->setCdfilial($cdfilial);
        $entity->setNrtarefa($nrtarefa);
        $entity->setNrplativtare($nrplativtare);
        return $entity;
    }

    public function  updateTxrfativtare($connection,$cdfilial, $nrtarefa, $nrplativtare,$description){
        $update = <<<SQL
            UPDATE 
                DESCPLATIV
            SET               
               TXRFATIVTARE = RAWTOHEX(:TXRFATIVTARE)
          WHERE
                NRTAREFA = :NRTAREFA
            AND NRPLATIVTARE = :NRPLATIVTARE       
            AND CDFILIAL = :CDFILIAL       
SQL;

        $params = array(
            "NRTAREFA" => $nrtarefa,
            "NRPLATIVTARE" => $nrplativtare,
            "CDFILIAL" => $cdfilial,
            "TXRFATIVTARE" => $description
        );
        $connection->executeQuery($update, $params);
    }
}
